#include "LPCSound.h"

LPCSound::LPCSound()
{
	Wire.begin();
}

word LPCSound::SetFreqBits(byte address, byte reg, byte index, word freqbits)
{
	set_register(address, reg + (index * 2), freqbits & 0xff);
	set_register(address, reg + (index * 2) + 1, (freqbits >> 8) & 0xff);
	return freqbits;
}

byte LPCSound::SetVolume(byte address, byte reg, byte index, byte volume)
{
	set_register(address, reg + index, volume);
	return volume;
}

byte LPCSound::SetMixer(byte address, byte reg, byte mixerbits)
{
	set_register(address, reg, mixerbits);
	return mixerbits;
}

byte LPCSound::set_register(byte address, byte reg, byte val)
{
	Wire.beginTransmission(address);
	Wire.write(reg);
	Wire.write(val);
	Wire.endTransmission();
	return val;
}
/*
int LPCSound::set_register(byte address, byte reg, byte* vals, int val_size)
{
	Wire.beginTransmission(address);
	int i;
	for (i = 0; i < val_size; i++){
		Wire.write(reg + i);
		Wire.write(vals + i);
	}
	Wire.endTransmission();
	return i;
}
*/