#include "PSG810.h"

using namespace PSG;

PSG810::PSG810()
{
	Reset();
}

void PSG810::Reset()
{
	for (int i = 0; i < PSG_COUNT; i++)
	{
		SetFreqBits((Channel)i, 0x00);
		SetVolume((Channel)i, 0x00);
	}
	SetMixer(0b01110111);
}

word PSG810::SetFreqBits(Channel ch, word freqbits)
{
	this->freqbits[ch] = freqbits & 0b0000111111111111;
	return LPCSound::SetFreqBits(ADDRESS_PSG, REG_INTERVALS, ch, this->freqbits[ch]);
}

byte PSG810::SetVolume(Channel ch, byte volume)
{
	volumes[ch] = (volume & 0b00001111);
	return LPCSound::SetVolume(ADDRESS_PSG, REG_VOLUMES, ch, volumes[ch]);
}

byte PSG810::SetMixer(byte mixerbits)
{
	mixer = (0b01110000 | (mixerbits & 0b0111));
	return LPCSound::SetMixer(ADDRESS_PSG, REG_MIXER, mixer);
}
