#include "SCC810.h"

using namespace SCC;

SCC810::SCC810()
{
	Reset();
}

void SCC810::Reset()
{
	for (int i = 0; i < SCC_COUNT; i++) {
		SetFreqBits((Channel)i, 0x00);
		SetVolume((Channel)i, 0x00);
		for (int j = 0; j < WT_SIZE; j++) { // WaveTable * 5ch Initialize
			set_register(ADDRESS_SCC, REG_WAVETABLES + (i * WT_SIZE) + j, 0x00);
		}
	}
	SetMixer(0b00000);
}

word SCC810::SetFreqBits(Channel ch, word freqbits)
{
	this->freqbits[ch] = freqbits & 0b0000111111111111;
	return LPCSound::SetFreqBits(ADDRESS_SCC, REG_INTERVALS, ch, this->freqbits[ch]);
}

byte SCC810::SetVolume(Channel ch, byte volume)
{
	volumes[ch] = (volume & 0b00001111);
	return LPCSound::SetVolume(ADDRESS_SCC, REG_VOLUMES, ch, volumes[ch]);
}

int SCC810::SetWaveTable(Channel ch, char* wt, int wt_size)
{
	int i;
	for (i = 0; i < wt_size && i < WT_SIZE; i++){
		set_register(ADDRESS_SCC, REG_WAVETABLES + (ch * WT_SIZE) + i, (byte)wt[i]);
	}
	return i;
//	return set_register(ADDRESS_SCC, REG_WAVETABLES + (ch * WT_SIZE), wt, WT_SIZE);
}

byte SCC810::SetMixer(byte mixerbits)
{
	mixer = (mixerbits & 0b00011111);
	return LPCSound::SetMixer(ADDRESS_SCC, REG_MIXER, mixer);
}
