#include <Wire.h>
#include <PSG810.h>
#include <SCC810.h>

SCC810* scc;

void setup() {
  scc = new SCC810();
  scc->SetMixer(0x00001);
  scc->SetVolume(SCC::SCC_A, 0x0f);
  char wave[] = "F0604010406020F0407050002030F0A0005010C0D0F0A080B000D090B0E0B090";
  char wt[SCC::WT_SIZE];
  strtowt(wave, strlen(wave), wt);
  scc->SetWaveTable(SCC::SCC_A, wt, sizeof(wt));
}

void loop() {
  sound(5, 'C');
  sound(5, 'D');
  sound(5, 'E');
  sound(5, 'F');
  sound(5, 'G');
  sound(5, 'A');
  sound(5, 'B');
  sound(6, 'C');
}

void sound(byte octave, char note){
  scc->SetFrequency(SCC::SCC_A, CalcFreqByMML(octave, note));
  delay(200);
}

void strtowt(char* str, int str_size, char* wt)
{
   for (int i = 0; i < str_size; i+=2){
     char b = (ctob(str[i]) * 0x10) + (ctob(str[i+1]));
     wt[i/2] = b;
   }
}
byte ctob(char c)
{
  byte ret = 0;
  if (c >= '0' && c <= '9')
    ret = c - '0';
  else if(c >= 'a' && c <= 'f')
    ret = c - 'a' + 10;
  else if (c >= 'A' && c <= 'F')
    ret = c - 'A' + 10;
  return ret;
}

